diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/CMakeLists.txt webkitgtk-2.34.5/Source/JavaScriptCore/CMakeLists.txt
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/CMakeLists.txt	2022-02-09 14:48:56.601602204 -0600
+++ webkitgtk-2.34.5/Source/JavaScriptCore/CMakeLists.txt	2022-02-09 15:51:17.597352663 -0600
@@ -75,16 +75,11 @@ set(JavaScriptCore_OBJECT_LUT_SOURCES
     runtime/IntlDateTimeFormatPrototype.cpp
     runtime/IntlDisplayNamesConstructor.cpp
     runtime/IntlDisplayNamesPrototype.cpp
-    runtime/IntlListFormatConstructor.cpp
-    runtime/IntlListFormatPrototype.cpp
-    runtime/IntlLocalePrototype.cpp
     runtime/IntlNumberFormatConstructor.cpp
     runtime/IntlNumberFormatPrototype.cpp
     runtime/IntlObject.cpp
     runtime/IntlPluralRulesConstructor.cpp
     runtime/IntlPluralRulesPrototype.cpp
-    runtime/IntlRelativeTimeFormatConstructor.cpp
-    runtime/IntlRelativeTimeFormatPrototype.cpp
     runtime/IntlSegmentIteratorPrototype.cpp
     runtime/IntlSegmenterConstructor.cpp
     runtime/IntlSegmenterPrototype.cpp
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources-input.xcfilelist webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources-input.xcfilelist
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources-input.xcfilelist	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources-input.xcfilelist	2022-02-09 15:51:17.597352663 -0600
@@ -137,16 +137,12 @@ $(PROJECT_DIR)/runtime/IntlDateTimeForma
 $(PROJECT_DIR)/runtime/IntlDateTimeFormatPrototype.cpp
 $(PROJECT_DIR)/runtime/IntlDisplayNamesConstructor.cpp
 $(PROJECT_DIR)/runtime/IntlDisplayNamesPrototype.cpp
-$(PROJECT_DIR)/runtime/IntlListFormatConstructor.cpp
-$(PROJECT_DIR)/runtime/IntlListFormatPrototype.cpp
 $(PROJECT_DIR)/runtime/IntlLocalePrototype.cpp
 $(PROJECT_DIR)/runtime/IntlNumberFormatConstructor.cpp
 $(PROJECT_DIR)/runtime/IntlNumberFormatPrototype.cpp
 $(PROJECT_DIR)/runtime/IntlObject.cpp
 $(PROJECT_DIR)/runtime/IntlPluralRulesConstructor.cpp
 $(PROJECT_DIR)/runtime/IntlPluralRulesPrototype.cpp
-$(PROJECT_DIR)/runtime/IntlRelativeTimeFormatConstructor.cpp
-$(PROJECT_DIR)/runtime/IntlRelativeTimeFormatPrototype.cpp
 $(PROJECT_DIR)/runtime/IntlSegmentIteratorPrototype.cpp
 $(PROJECT_DIR)/runtime/IntlSegmenterConstructor.cpp
 $(PROJECT_DIR)/runtime/IntlSegmenterPrototype.cpp
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources.make webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources.make
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources.make	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources.make	2022-02-09 15:51:17.597352663 -0600
@@ -158,16 +158,12 @@ OBJECT_LUT_HEADERS = \
     IntlDateTimeFormatPrototype.lut.h \
     IntlDisplayNamesConstructor.lut.h \
     IntlDisplayNamesPrototype.lut.h \
-    IntlListFormatConstructor.lut.h \
-    IntlListFormatPrototype.lut.h \
     IntlLocalePrototype.lut.h \
     IntlNumberFormatConstructor.lut.h \
     IntlNumberFormatPrototype.lut.h \
     IntlObject.lut.h \
     IntlPluralRulesConstructor.lut.h \
     IntlPluralRulesPrototype.lut.h \
-    IntlRelativeTimeFormatConstructor.lut.h \
-    IntlRelativeTimeFormatPrototype.lut.h \
     IntlSegmentIteratorPrototype.lut.h \
     IntlSegmenterConstructor.lut.h \
     IntlSegmenterPrototype.lut.h \
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources-output.xcfilelist webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources-output.xcfilelist
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/DerivedSources-output.xcfilelist	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/DerivedSources-output.xcfilelist	2022-02-09 15:51:17.597352663 -0600
@@ -28,16 +28,12 @@ $(BUILT_PRODUCTS_DIR)/DerivedSources/Jav
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlDateTimeFormatPrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlDisplayNamesConstructor.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlDisplayNamesPrototype.lut.h
-$(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlListFormatConstructor.lut.h
-$(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlListFormatPrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlLocalePrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlNumberFormatConstructor.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlNumberFormatPrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlObject.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlPluralRulesConstructor.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlPluralRulesPrototype.lut.h
-$(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlRelativeTimeFormatConstructor.lut.h
-$(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlRelativeTimeFormatPrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlSegmentIteratorPrototype.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlSegmenterConstructor.lut.h
 $(BUILT_PRODUCTS_DIR)/DerivedSources/JavaScriptCore/IntlSegmenterPrototype.lut.h
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/CommonIdentifiers.h webkitgtk-2.34.5/Source/JavaScriptCore/runtime/CommonIdentifiers.h
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/CommonIdentifiers.h	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/CommonIdentifiers.h	2022-02-09 15:51:17.601352684 -0600
@@ -42,9 +42,7 @@
     macro(Function) \
     macro(Infinity) \
     macro(Intl) \
-    macro(ListFormat) \
     macro(Loader) \
-    macro(Locale) \
     macro(Map) \
     macro(NaN) \
     macro(Number) \
@@ -54,7 +52,6 @@
     macro(Promise) \
     macro(Reflect) \
     macro(RegExp) \
-    macro(RelativeTimeFormat) \
     macro(RemotePlayback) \
     macro(Segmenter) \
     macro(Set) \
@@ -118,7 +115,6 @@
     macro(exec) \
     macro(executionCount) \
     macro(exitKind) \
-    macro(fallback) \
     macro(flags) \
     macro(forEach) \
     macro(formatMatcher) \
@@ -159,7 +155,6 @@
     macro(jettisonReason) \
     macro(join) \
     macro(language) \
-    macro(languageDisplay) \
     macro(largestUnit) \
     macro(lastIndex) \
     macro(length) \
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlCollator.cpp webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlCollator.cpp
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlCollator.cpp	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlCollator.cpp	2022-02-09 15:51:26.129397722 -0600
@@ -33,6 +33,7 @@
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
 #include <wtf/HexNumber.h>
+#include <unicode/ucol.h>
 
 namespace JSC {
 
@@ -42,6 +43,12 @@ namespace IntlCollatorInternal {
 constexpr bool verbose = false;
 }
 
+void IntlCollator::UCollatorDeleter::operator()(UCollator* collator) const
+{
+    if (collator)
+        ucol_close(collator);
+}
+
 IntlCollator* IntlCollator::create(VM& vm, Structure* structure)
 {
     IntlCollator* format = new (NotNull, allocateCell<IntlCollator>(vm.heap)) IntlCollator(vm, structure);
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlCollator.h webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlCollator.h
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlCollator.h	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlCollator.h	2022-02-09 15:51:26.129397722 -0600
@@ -27,9 +27,10 @@
 #pragma once
 
 #include "IntlObject.h"
-#include <unicode/ucol.h>
 #include <wtf/unicode/icu/ICUHelpers.h>
 
+struct UCollator;
+
 namespace JSC {
 
 enum class RelevantExtensionKey : uint8_t;
@@ -92,7 +93,9 @@ private:
     enum class Sensitivity : uint8_t { Base, Accent, Case, Variant };
     enum class CaseFirst : uint8_t { Upper, Lower, False };
 
-    using UCollatorDeleter = ICUDeleter<ucol_close>;
+    struct UCollatorDeleter {
+        void operator()(UCollator*) const;
+    };
 
     static ASCIILiteral usageString(Usage);
     static ASCIILiteral sensitivityString(Sensitivity);
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormat.cpp webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormat.cpp
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormat.cpp	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormat.cpp	2022-02-09 15:51:26.129397722 -0600
@@ -66,6 +66,12 @@ namespace IntlDateTimeFormatInternal {
 static constexpr bool verbose = false;
 }
 
+void IntlDateTimeFormat::UDateFormatDeleter::operator()(UDateFormat* dateFormat) const
+{
+    if (dateFormat)
+        udat_close(dateFormat);
+}
+
 IntlDateTimeFormat* IntlDateTimeFormat::create(VM& vm, Structure* structure)
 {
     IntlDateTimeFormat* format = new (NotNull, allocateCell<IntlDateTimeFormat>(vm.heap)) IntlDateTimeFormat(vm, structure);
@@ -1291,6 +1297,7 @@ JSValue IntlDateTimeFormat::format(JSGlo
     return jsString(vm, String(result));
 }
 
+#if 0
 static ASCIILiteral partTypeString(UDateFormatField field)
 {
     switch (field) {
@@ -1418,6 +1425,7 @@ JSValue IntlDateTimeFormat::formatToPart
 
     return parts;
 }
+#endif
 
 UDateIntervalFormat* IntlDateTimeFormat::createDateIntervalFormatIfNecessary(JSGlobalObject* globalObject)
 {
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormat.h webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormat.h
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormat.h	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormat.h	2022-02-09 15:51:26.133397744 -0600
@@ -28,7 +28,6 @@
 
 #include "JSObject.h"
 #include <unicode/udat.h>
-#include <wtf/unicode/icu/ICUHelpers.h>
 
 struct UDateIntervalFormat;
 
@@ -126,7 +125,9 @@ private:
     static void replaceHourCycleInSkeleton(Vector<UChar, 32>&, bool hour12);
     static void replaceHourCycleInPattern(Vector<UChar, 32>&, HourCycle);
 
-    using UDateFormatDeleter = ICUDeleter<udat_close>;
+    struct UDateFormatDeleter {
+        void operator()(UDateFormat*) const;
+    };
 
     WriteBarrier<JSBoundFunction> m_boundFormat;
     std::unique_ptr<UDateFormat, UDateFormatDeleter> m_dateFormat;
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormatPrototype.cpp webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormatPrototype.cpp
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDateTimeFormatPrototype.cpp	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDateTimeFormatPrototype.cpp	2022-02-09 15:51:26.133397744 -0600
@@ -39,7 +39,6 @@ namespace JSC {
 static JSC_DECLARE_CUSTOM_GETTER(intlDateTimeFormatPrototypeGetterFormat);
 static JSC_DECLARE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncFormatRange);
 static JSC_DECLARE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncFormatRangeToParts);
-static JSC_DECLARE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncFormatToParts);
 static JSC_DECLARE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncResolvedOptions);
 static JSC_DECLARE_HOST_FUNCTION(intlDateTimeFormatFuncFormatDateTime);
 
@@ -55,7 +54,6 @@ const ClassInfo IntlDateTimeFormatProtot
 @begin dateTimeFormatPrototypeTable
   format                intlDateTimeFormatPrototypeGetterFormat              DontEnum|ReadOnly|CustomAccessor
   formatRange           intlDateTimeFormatPrototypeFuncFormatRange           DontEnum|Function 2
-  formatToParts         intlDateTimeFormatPrototypeFuncFormatToParts         DontEnum|Function 1
   resolvedOptions       intlDateTimeFormatPrototypeFuncResolvedOptions       DontEnum|Function 0
 @end
 */
@@ -142,6 +140,7 @@ JSC_DEFINE_CUSTOM_GETTER(intlDateTimeFor
     return JSValue::encode(boundFormat);
 }
 
+#if 0
 JSC_DEFINE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncFormatToParts, (JSGlobalObject* globalObject, CallFrame* callFrame))
 {
     VM& vm = globalObject->vm();
@@ -167,6 +166,7 @@ JSC_DEFINE_HOST_FUNCTION(intlDateTimeFor
 
     RELEASE_AND_RETURN(scope, JSValue::encode(dateTimeFormat->formatToParts(globalObject, value)));
 }
+#endif
 
 // http://tc39.es/proposal-intl-DateTimeFormat-formatRange/#sec-intl.datetimeformat.prototype.formatRange
 JSC_DEFINE_HOST_FUNCTION(intlDateTimeFormatPrototypeFuncFormatRange, (JSGlobalObject* globalObject, CallFrame* callFrame))
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDisplayNames.cpp webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDisplayNames.cpp
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDisplayNames.cpp	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDisplayNames.cpp	2022-02-09 15:51:26.133397744 -0600
@@ -26,7 +26,6 @@
 #include "config.h"
 #include "IntlDisplayNames.h"
 
-#include "IntlCache.h"
 #include "IntlObjectInlines.h"
 #include "JSCInlines.h"
 #include "ObjectConstructor.h"
@@ -96,7 +95,7 @@ void IntlDisplayNames::initializeDisplay
     m_style = intlOption<Style>(globalObject, options, vm.propertyNames->style, { { "narrow"_s, Style::Narrow }, { "short"_s, Style::Short }, { "long"_s, Style::Long } }, "style must be either \"narrow\", \"short\", or \"long\""_s, Style::Long);
     RETURN_IF_EXCEPTION(scope, void());
 
-    auto type = intlOption<std::optional<Type>>(globalObject, options, vm.propertyNames->type, { { "language"_s, Type::Language }, { "region"_s, Type::Region }, { "script"_s, Type::Script }, { "currency"_s, Type::Currency }, { "calendar"_s, Type::Calendar }, { "dateTimeField"_s, Type::DateTimeField } }, "type must be either \"language\", \"region\", \"script\", \"currency\", \"calendar\", or \"dateTimeField\""_s, std::nullopt);
+    auto type = intlOption<std::optional<Type>>(globalObject, options, vm.propertyNames->type, { { "language"_s, Type::Language }, { "region"_s, Type::Region }, { "script"_s, Type::Script }, { "currency"_s, Type::Currency } }, "type must be either \"language\", \"region\", \"script\", or \"currency\""_s, std::nullopt);
     RETURN_IF_EXCEPTION(scope, void());
     if (!type) {
         throwTypeError(globalObject, scope, "type must not be undefined"_s);
@@ -104,10 +103,7 @@ void IntlDisplayNames::initializeDisplay
     }
     m_type = type.value();
 
-    m_fallback = intlOption<Fallback>(globalObject, options, vm.propertyNames->fallback, { { "code"_s, Fallback::Code }, { "none"_s, Fallback::None } }, "fallback must be either \"code\" or \"none\""_s, Fallback::Code);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    m_languageDisplay = intlOption<LanguageDisplay>(globalObject, options, vm.propertyNames->languageDisplay, { { "dialect"_s, LanguageDisplay::Dialect }, { "standard"_s, LanguageDisplay::Standard } }, "languageDisplay must be either \"dialect\" or \"standard\""_s, LanguageDisplay::Dialect);
+    m_fallback = intlOption<Fallback>(globalObject, options, Identifier::fromString(vm, "fallback"), { { "code"_s, Fallback::Code }, { "none"_s, Fallback::None } }, "fallback must be either \"code\" or \"none\""_s, Fallback::Code);
     RETURN_IF_EXCEPTION(scope, void());
 
 #if HAVE(ICU_U_LOCALE_DISPLAY_NAMES)
@@ -115,8 +111,9 @@ void IntlDisplayNames::initializeDisplay
 
     UDisplayContext contexts[] = {
         // en_GB displays as 'English (United Kingdom)' (Standard Names) or 'British English' (Dialect Names).
+        // We use Dialect Names here, aligned to the examples in the spec draft and V8's behavior.
         // https://github.com/tc39/proposal-intl-displaynames#language-display-names
-        (m_type == Type::Language && m_languageDisplay == LanguageDisplay::Standard) ? UDISPCTX_STANDARD_NAMES : UDISPCTX_DIALECT_NAMES,
+        UDISPCTX_DIALECT_NAMES,
 
         // Capitailization mode can be picked from several options. Possibly either UDISPCTX_CAPITALIZATION_NONE or UDISPCTX_CAPITALIZATION_FOR_STANDALONE is
         // preferable in Intl.DisplayNames. We use UDISPCTX_CAPITALIZATION_FOR_STANDALONE because it makes standalone date format better (fr "Juillet 2008" in ICU test suites),
@@ -156,82 +153,10 @@ JSValue IntlDisplayNames::of(JSGlobalObj
     auto code = codeValue.toWTFString(globalObject);
     RETURN_IF_EXCEPTION(scope, { });
 
-    // https://tc39.es/proposal-intl-displaynames/#sec-canonicalcodefordisplaynames
-    auto canonicalizeCodeForDisplayNames = [](Type type, String&& code) -> CString {
-        ASSERT(code.isAllASCII());
-        switch (type) {
-        case Type::Language: {
-            return canonicalizeUnicodeLocaleID(code.ascii()).ascii();
-        }
-        case Type::Region: {
-            // Let code be the result of mapping code to upper case as described in 6.1.
-            auto result = code.ascii();
-            char* mutableData = result.mutableData();
-            for (unsigned index = 0; index < result.length(); ++index)
-                mutableData[index] = toASCIIUpper(mutableData[index]);
-            return result;
-        }
-        case Type::Script: {
-            // Let code be the result of mapping the first character in code to upper case, and mapping the second, third and fourth character in code to lower case, as described in 6.1.
-            auto result = code.ascii();
-            char* mutableData = result.mutableData();
-            if (result.length() >= 1)
-                mutableData[0] = toASCIIUpper(mutableData[0]);
-            for (unsigned index = 1; index < result.length(); ++index)
-                mutableData[index] = toASCIILower(mutableData[index]);
-            return result;
-        }
-        case Type::Currency:
-            ASSERT_NOT_REACHED();
-            break;
-        case Type::Calendar: {
-            // Let code be the result of mapping code to lower case as described in 6.1.
-            String lowered = code.convertToASCIILowercase();
-            if (auto mapped = mapBCP47ToICUCalendarKeyword(lowered))
-                lowered = WTFMove(mapped.value());
-            return lowered.ascii();
-        }
-        case Type::DateTimeField: {
-            ASSERT_NOT_REACHED();
-            break;
-        }
-        }
-        return { };
-    };
-
     Vector<UChar, 32> buffer;
     UErrorCode status = U_ZERO_ERROR;
-    CString canonicalCode;
-    switch (m_type) {
-    case Type::Language: {
-        if (!isUnicodeLanguageId(code)) {
-            throwRangeError(globalObject, scope, "argument is not a language id"_s);
-            return { };
-        }
-        canonicalCode = canonicalizeCodeForDisplayNames(m_type, WTFMove(code));
-        // Do not use uldn_languageDisplayName since it is not expected one for this "language" type. It returns "en-US" for "en-US" code, instead of "American English".
-        status = callBufferProducingFunction(uldn_localeDisplayName, m_displayNames.get(), canonicalCode.data(), buffer);
-        break;
-    }
-    case Type::Region: {
-        if (!isUnicodeRegionSubtag(code)) {
-            throwRangeError(globalObject, scope, "argument is not a region subtag"_s);
-            return { };
-        }
-        canonicalCode = canonicalizeCodeForDisplayNames(m_type, WTFMove(code));
-        status = callBufferProducingFunction(uldn_regionDisplayName, m_displayNames.get(), canonicalCode.data(), buffer);
-        break;
-    }
-    case Type::Script: {
-        if (!isUnicodeScriptSubtag(code)) {
-            throwRangeError(globalObject, scope, "argument is not a script subtag"_s);
-            return { };
-        }
-        canonicalCode = canonicalizeCodeForDisplayNames(m_type, WTFMove(code));
-        status = callBufferProducingFunction(uldn_scriptDisplayName, m_displayNames.get(), canonicalCode.data(), buffer);
-        break;
-    }
-    case Type::Currency: {
+
+    if (m_type == Type::Currency) {
         // We do not use uldn_keyValueDisplayName + "currency". This is because of the following reasons.
         //     1. ICU does not respect UDISPCTX_LENGTH_FULL / UDISPCTX_LENGTH_SHORT in its implementation.
         //     2. There is no way to set "narrow" style in ULocaleDisplayNames while currency have "narrow" symbol style.
@@ -277,82 +202,84 @@ JSValue IntlDisplayNames::of(JSGlobalObj
         // ICU API document.
         // > Returns pointer to display string of 'len' UChars. If the resource data contains no entry for 'currency', then 'currency' itself is returned.
         if (status == U_USING_DEFAULT_WARNING && result == currency)
-            return (m_fallback == Fallback::None) ? jsUndefined() : jsString(vm, String(currency, 3));
+            return (m_fallback == Fallback::None) ? jsUndefined() : codeValue;
         return jsString(vm, String(result, length));
     }
-    case Type::Calendar: {
-        // a. If code does not match the Unicode Locale Identifier type nonterminal, throw a RangeError exception.
-        if (!isUnicodeLocaleIdentifierType(code)) {
-            throwRangeError(globalObject, scope, "argument is not a calendar code"_s);
-            return { };
-        }
-        canonicalCode = canonicalizeCodeForDisplayNames(m_type, WTFMove(code));
-        status = callBufferProducingFunction(uldn_keyValueDisplayName, m_displayNames.get(), "calendar", canonicalCode.data(), buffer);
-        break;
-    }
-    case Type::DateTimeField: {
-        // We do not use uldn_keyValueDisplayName since it cannot handle narrow length.
-        // Instead, we use udatpg_getFieldDisplayName.
-
-        // https://tc39.es/intl-displaynames-v2/#sec-isvaliddatetimefieldcode
-        auto isValidDateTimeFieldCode = [](const String& code) -> std::optional<UDateTimePatternField> {
-            if (code == "era"_s)
-                return UDATPG_ERA_FIELD;
-            if (code == "year"_s)
-                return UDATPG_YEAR_FIELD;
-            if (code == "quarter"_s)
-                return UDATPG_QUARTER_FIELD;
-            if (code == "month"_s)
-                return UDATPG_MONTH_FIELD;
-            if (code == "weekOfYear"_s)
-                return UDATPG_WEEK_OF_YEAR_FIELD;
-            if (code == "weekday"_s)
-                return UDATPG_WEEKDAY_FIELD;
-            if (code == "day"_s)
-                return UDATPG_DAY_FIELD;
-            if (code == "dayPeriod"_s)
-                return UDATPG_DAYPERIOD_FIELD;
-            if (code == "hour"_s)
-                return UDATPG_HOUR_FIELD;
-            if (code == "minute"_s)
-                return UDATPG_MINUTE_FIELD;
-            if (code == "second"_s)
-                return UDATPG_SECOND_FIELD;
-            if (code == "timeZoneName"_s)
-                return UDATPG_ZONE_FIELD;
-            return std::nullopt;
-        };
 
-        auto field = isValidDateTimeFieldCode(code);
-        if (!field) {
-            throwRangeError(globalObject, scope, "argument is not a dateTimeField code"_s);
-            return { };
+    // https://tc39.es/proposal-intl-displaynames/#sec-canonicalcodefordisplaynames
+    auto canonicalizeCodeForDisplayNames = [](Type type, const String& code) -> CString {
+        ASSERT(code.isAllASCII());
+        auto result = code.ascii();
+        char* mutableData = result.mutableData();
+        switch (type) {
+        case Type::Language: {
+            // Let code be the result of mapping code to lower case as described in 6.1.
+            for (unsigned index = 0; index < result.length(); ++index)
+                mutableData[index] = toASCIILower(mutableData[index]);
+            break;
         }
-
-        UDateTimePGDisplayWidth style = UDATPG_WIDE;
-        switch (m_style) {
-        case Style::Long:
-            style = UDATPG_WIDE;
+        case Type::Region: {
+            // Let code be the result of mapping code to upper case as described in 6.1.
+            for (unsigned index = 0; index < result.length(); ++index)
+                mutableData[index] = toASCIIUpper(mutableData[index]);
             break;
-        case Style::Short:
-            style = UDATPG_ABBREVIATED;
+        }
+        case Type::Script: {
+            // Let code be the result of mapping the first character in code to upper case, and mapping the second, third and fourth character in code to lower case, as described in 6.1.
+            if (result.length() >= 1)
+                mutableData[0] = toASCIIUpper(mutableData[0]);
+            for (unsigned index = 1; index < result.length(); ++index)
+                mutableData[index] = toASCIILower(mutableData[index]);
             break;
-        case Style::Narrow:
-            style = UDATPG_NARROW;
+        }
+        case Type::Currency:
+            ASSERT_NOT_REACHED();
             break;
         }
+        return result;
+    };
 
-        buffer = vm.intlCache().getFieldDisplayName(m_localeCString.data(), field.value(), style, status);
-        if (U_FAILURE(status))
-            return (m_fallback == Fallback::None) ? jsUndefined() : jsString(vm, code);
-        return jsString(vm, String(buffer));
+    switch (m_type) {
+    case Type::Language: {
+        // If code does not matches the unicode_language_id production, throw a RangeError exception
+        if (!isUnicodeLanguageId(code)) {
+            throwRangeError(globalObject, scope, "argument is not a language id"_s);
+            return { };
+        }
+        auto language = canonicalizeCodeForDisplayNames(m_type, code);
+        // Do not use uldn_languageDisplayName since it is not expected one for this "language" type. It returns "en-US" for "en-US" code, instead of "American English".
+        status = callBufferProducingFunction(uldn_localeDisplayName, m_displayNames.get(), language.data(), buffer);
+        break;
+    }
+    case Type::Region: {
+        // If code does not matches the unicode_region_subtag production, throw a RangeError exception
+        if (!isUnicodeRegionSubtag(code)) {
+            throwRangeError(globalObject, scope, "argument is not a region subtag"_s);
+            return { };
+        }
+        auto region = canonicalizeCodeForDisplayNames(m_type, code);
+        status = callBufferProducingFunction(uldn_regionDisplayName, m_displayNames.get(), region.data(), buffer);
+        break;
     }
+    case Type::Script: {
+        // If code does not matches the unicode_script_subtag production, throw a RangeError exception
+        if (!isUnicodeScriptSubtag(code)) {
+            throwRangeError(globalObject, scope, "argument is not a script subtag"_s);
+            return { };
+        }
+        auto script = canonicalizeCodeForDisplayNames(m_type, code);
+        status = callBufferProducingFunction(uldn_scriptDisplayName, m_displayNames.get(), script.data(), buffer);
+        break;
+    }
+    case Type::Currency:
+        ASSERT_NOT_REACHED();
+        break;
     }
     if (U_FAILURE(status)) {
         // uldn_localeDisplayName, uldn_regionDisplayName, and uldn_scriptDisplayName return U_ILLEGAL_ARGUMENT_ERROR if the display-name is not found.
         // We should return undefined if fallback is "none". Otherwise, we should return input value.
         if (status == U_ILLEGAL_ARGUMENT_ERROR)
-            return (m_fallback == Fallback::None) ? jsUndefined() : jsString(vm, String(canonicalCode.data(), canonicalCode.length()));
+            return (m_fallback == Fallback::None) ? jsUndefined() : codeValue;
         return throwTypeError(globalObject, scope, "Failed to query a display name."_s);
     }
     return jsString(vm, String(buffer));
@@ -371,9 +298,7 @@ JSObject* IntlDisplayNames::resolvedOpti
     options->putDirect(vm, vm.propertyNames->locale, jsString(vm, m_locale));
     options->putDirect(vm, vm.propertyNames->style, jsNontrivialString(vm, styleString(m_style)));
     options->putDirect(vm, vm.propertyNames->type, jsNontrivialString(vm, typeString(m_type)));
-    options->putDirect(vm, vm.propertyNames->fallback, jsNontrivialString(vm, fallbackString(m_fallback)));
-    if (m_type == Type::Language)
-        options->putDirect(vm, vm.propertyNames->languageDisplay, jsNontrivialString(vm, languageDisplayString(m_languageDisplay)));
+    options->putDirect(vm, Identifier::fromString(vm, "fallback"), jsNontrivialString(vm, fallbackString(m_fallback)));
     return options;
 }
 
@@ -402,10 +327,6 @@ ASCIILiteral IntlDisplayNames::typeStrin
         return "script"_s;
     case Type::Currency:
         return "currency"_s;
-    case Type::Calendar:
-        return "calendar"_s;
-    case Type::DateTimeField:
-        return "dateTimeField"_s;
     }
     ASSERT_NOT_REACHED();
     return ASCIILiteral::null();
@@ -421,18 +342,6 @@ ASCIILiteral IntlDisplayNames::fallbackS
     }
     ASSERT_NOT_REACHED();
     return ASCIILiteral::null();
-}
-
-ASCIILiteral IntlDisplayNames::languageDisplayString(LanguageDisplay languageDisplay)
-{
-    switch (languageDisplay) {
-    case LanguageDisplay::Dialect:
-        return "dialect"_s;
-    case LanguageDisplay::Standard:
-        return "standard"_s;
-    }
-    ASSERT_NOT_REACHED();
-    return ASCIILiteral::null();
 }
 
 } // namespace JSC
diff -urpN webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDisplayNames.h webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDisplayNames.h
--- webkitgtk-2.34.5.gstreamer/Source/JavaScriptCore/runtime/IntlDisplayNames.h	2021-10-21 03:52:07.000000000 -0500
+++ webkitgtk-2.34.5/Source/JavaScriptCore/runtime/IntlDisplayNames.h	2022-02-09 15:51:26.133397744 -0600
@@ -72,14 +72,12 @@ private:
     void finishCreation(VM&);
 
     enum class Style : uint8_t { Narrow, Short, Long };
-    enum class Type : uint8_t { Language, Region, Script, Currency, Calendar, DateTimeField };
+    enum class Type : uint8_t { Language, Region, Script, Currency };
     enum class Fallback : uint8_t { Code, None };
-    enum class LanguageDisplay : uint8_t { Dialect, Standard };
 
     static ASCIILiteral styleString(Style);
     static ASCIILiteral typeString(Type);
     static ASCIILiteral fallbackString(Fallback);
-    static ASCIILiteral languageDisplayString(LanguageDisplay);
 
     using ULocaleDisplayNamesDeleter = ICUDeleter<uldn_close>;
     std::unique_ptr<ULocaleDisplayNames, ULocaleDisplayNamesDeleter> m_displayNames;
@@ -90,7 +88,6 @@ private:
     Style m_style { Style::Long };
     Type m_type { Type::Language };
     Fallback m_fallback { Fallback::Code };
-    LanguageDisplay m_languageDisplay { LanguageDisplay::Dialect };
 };
 
 } // namespace JSC
